## ide-configuration-manager ide-configuration-manager |

## Functions

IdeConfiguration * | ide_configuration_manager_get_current ()
void | ide_configuration_manager_set_current ()
IdeConfiguration * | ide_configuration_manager_get_configuration ()
void | ide_configuration_manager_duplicate ()
void | ide_configuration_manager_delete ()
void | ide_configuration_manager_save_async ()
gboolean | ide_configuration_manager_save_finish ()
gboolean | ide_configuration_manager_get_ready ()

## Properties

IdeConfiguration * | current | Read / Write
gchar * | current-display-name | Read
gboolean | ready | Read

## Signals

void | invalidate | Run Last

## Types and Values

#define | IDE_TYPE_CONFIGURATION_MANAGER
| IdeConfigurationManager

## Object Hierarchy

        GObject
        ╰── IdeObject
            ╰── IdeConfigurationManager

## Implemented Interfaces

IdeConfigurationManager implements GListModel and GAsyncInitable.

## Description

## Functions

### ide_configuration_manager_get_current ()

    IdeConfiguration *
    ide_configuration_manager_get_current (IdeConfigurationManager *self);

Gets the current configuration to use for building.

Many systems allow you to pass a configuration in instead of relying on the default configuration. This gets the default configuration that various background items might use, such as tags builders which need to discover settings.

#### Parameters

self | An IdeConfigurationManager |

#### Returns

An IdeConfiguration.

[transfer none]

### ide_configuration_manager_set_current ()

    void
    ide_configuration_manager_set_current (IdeConfigurationManager *self,
                                           IdeConfiguration *configuration);

### ide_configuration_manager_get_configuration ()

    IdeConfiguration *
    ide_configuration_manager_get_configuration
                                   (IdeConfigurationManager *self,
                                    const gchar *id);

Gets the IdeConfiguration by id. See `ide_configuration_get_id()`.

#### Parameters

self | An IdeConfigurationManager |
id | The string identifier of the configuration |

#### Returns

An IdeConfiguration or `NULL` if the configuration could not be found.

[transfer none][nullable]

### ide_configuration_manager_duplicate ()

    void
    ide_configuration_manager_duplicate (IdeConfigurationManager *self,
                                         IdeConfiguration *config);

### ide_configuration_manager_delete ()

    void
    ide_configuration_manager_delete (IdeConfigurationManager *self,
                                      IdeConfiguration *config);

### ide_configuration_manager_save_async ()

    void
    ide_configuration_manager_save_async (IdeConfigurationManager *self,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

### ide_configuration_manager_save_finish ()

    gboolean
    ide_configuration_manager_save_finish (IdeConfigurationManager *self,
                                           GAsyncResult *result,
                                           GError **error);

### ide_configuration_manager_get_ready ()

    gboolean
    ide_configuration_manager_get_ready (IdeConfigurationManager *self);

This returns `TRUE` if the current configuration is ready for usage.

This is equivalent to checking the ready property of the current configuration. It allows consumers to not need to track changes to the current configuration.

#### Parameters

self | an IdeConfigurationManager |

#### Returns

`TRUE` if the current configuration is ready for usage; otherwise `FALSE`.

Since: 3.28

## Types and Values

### IDE_TYPE_CONFIGURATION_MANAGER

    #define IDE_TYPE_CONFIGURATION_MANAGER (ide_configuration_manager_get_type())

### IdeConfigurationManager

    typedef struct _IdeConfigurationManager IdeConfigurationManager;

## Property Details

### The `“current”` property

      “current”                  IdeConfiguration *

The current configuration for the context.

Flags: Read / Write

### The `“current-display-name”` property

      “current-display-name”     gchar *

The display name of the current configuration.

Flags: Read

Default value: NULL

### The `“ready”` property

      “ready”                    gboolean

If the current configuration is ready.

Flags: Read

Default value: FALSE

## Signal Details

### The `“invalidate”` signal

    void
    user_function (IdeConfigurationManager *self,
                   gpointer                 user_data)

This signal is emitted any time a new configuration is selected or the currently selected configurations state changes.

#### Parameters

self | an IdeConfigurationManager |
user_data | user data set when the signal handler was connected. |

Flags: Run Last